/* ------------------------------------------------------
Dave DataGram HyperText Transfer Protocol Deamon

Unit: ddghttpd.cpp
Text: DDGHTTPd Main Server Program

Version: 0.00/a
Copyright: GPL
------------------------------------------------------ */



#define MAX_DATA_SIZE 4096

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <sys/utsname.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>

#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <errno.h>
#include <limits.h>

#include "debug.h"

void shutdown(int sig);

static int Write(int sock_descr, const void *msg_ptr, int bytes_to_send);
static int Get_Host_Name(char *buffer, int len);

static const char _message[]="Hello, World\n";
char transmit[120]="";

int main(int argc, char *argv[])
{
(void) signal(SIGINT,shutdown);
(void) signal(SIGKILL,shutdown);
int svc_socket=0, on=0, port=0;
struct hostent *host_ptr=0;
char hostname[80]="";
struct sockaddr_in server_name={ 0 };
struct linger linger = { 0 };
//port=13200;
if (2 != argc)
	{
	printf("Usage: %s <port>\n",argv[0]);
	exit(EXIT_FAILURE);
	}
port=strtol(argv[1],0,10);
FILE *dptr;
char debugfile[512]="logs/server.";
strcat(debugfile,argv[1]);
dptr=fopen(debugfile,"a");
debug.stream=dptr;
debug.Write("DDG DaveDataGram Socket Server Starting",0);
printf("DDG DaveDataGram Starting Ok\n");
debug.Write(argv[1],0);
// NEW
char buffer[MAX_DATA_SIZE]="";
int readstatus;

svc_socket=socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
if (-1==svc_socket)
	{
	debug.Write("SVC_Socket Error",10);
	}
setsockopt(svc_socket, SOL_SOCKET, SO_REUSEADDR,
	(const char *)&on, sizeof(on));
linger.l_onoff=1;
linger.l_linger=30;
setsockopt(svc_socket, SOL_SOCKET, SO_LINGER,
	(const char *)&linger, sizeof(linger));
Get_Host_Name(hostname,sizeof(hostname));
// -1 fail
host_ptr = gethostbyname(hostname);
// 0 = failure
memset(&server_name,0,sizeof(server_name));
memcpy(&server_name.sin_addr, host_ptr->h_addr, host_ptr->h_length);
server_name.sin_addr.s_addr=htonl(INADDR_ANY);
server_name.sin_family=AF_INET;
server_name.sin_port=htons(port);
bind(svc_socket, (struct sockaddr *) &server_name, sizeof(server_name));
// -1 failure
listen(svc_socket,5);
// -1 failure

debug.Write("Server Started Ok",0);

for(;;)
{
struct sockaddr_in clnt_name={0};
int clnt_socket=0,clnt_len=sizeof(clnt_name);
printf("Beginning Socket Accept\n");
clnt_socket=accept(svc_socket, (struct sockaddr *)&clnt_name,
	&clnt_len);
if (clnt_socket==-1)
	{
	printf("Socket Accept Error\n");
	}
else
	printf("Socket Accept %d\n",clnt_socket);
if (-1 == getpeername(clnt_socket, (struct sockaddr *)&clnt_name,
	&clnt_len))
	debug.Write("getpeername failed",2);
else
	{
	debug.Write("Connection Request",0);
	debug.Write(inet_ntoa(clnt_name.sin_addr),0);
	}
printf("Got peer or whatever...\n");
readstatus=read(clnt_socket,buffer,sizeof(buffer)-1);
printf("Read Status %d\n",readstatus);
debug.Write("Raw Request as Follows",8);
debug.Write(buffer,8);
char received[MAX_DATA_SIZE]="";
for (int a=0; a<256; a++)
	received[a]=0;
printf("Analysing received data\n");
for (int a=0; a<(readstatus); a++)
	if ( (buffer[a]>31)&&(buffer[a]<128) )
	received[a]=buffer[a];

char request[MAX_DATA_SIZE]="";
int start=0,finish=0;
for (int z=0; z<strlen(received); z++)
	{
	if (received[z]=='/')
		{
		start=z+1;
		z=strlen(received+2);
		}
	}
for (int z=start; z<strlen(received); z++)
	{
	if (received[z]==' ')
		{
		finish=z-1;
		z=strlen(received+2);
		}
	}
// printf("St %d Fi %d\n",start,finish);
if (finish>start)
	{
	for (int z=start; z<=finish; z++)
		request[z-start]=received[z];
	}
debug.Write("Document Request as follows:",8);
char prefix[4096]="data/";
strcat(prefix,request);
strcpy(request,prefix);
debug.Write(request,8);
printf("Doc request found to be: %s\n",request);
if (readstatus>0)
	{
	buffer[readstatus]=0;
	//printf("Received %d bytes: %s\n",readstatus,buffer);
	}

// NEW BITTY

//while (0< (readstatus=read(clnt_socket, buffer, sizeof(buffer)-1)))
//	{
//	buffer[readstatus]='\0';
//	printf("Received %d bytes: %s\n",readstatus,buffer);
//	}

// END OF NEW BITTY
debug.Write("File request for",5);
debug.Write(received,5);
FILE *fptr;
fptr=0;
fptr=fopen(request,"r");
if (fptr<=0)
	{
	strcpy(transmit,"404 - File Not Found\n");
	Write(clnt_socket, transmit, strlen(transmit));
	}
else
	{
	// transmit file
	//strcpy(transmit,"007 - File to Follow\n");
	//Write(clnt_socket,transmit,strlen(transmit));
	char data[4096];
	for (int f=0; f<4096; f++) data[f]=0;
	fseek(fptr,0,0);
	clearerr(fptr);
	int getthehellout=0;
	int loaded=0;
	while ((0==feof(fptr)) && (getthehellout==0))
		{
		loaded=fgets(data,4096,fptr);
		debug.Write(data,8);
		printf("%s",data);
		printf("Loaded %d\n",loaded);
		Write(clnt_socket,data,4096); // strlen(data)
		printf("Written Data of length %d\n",strlen(data));
		if (loaded==0) getthehellout=1;
		for (int f=0; f<4096; f++) data[f]=0;
		}
	clearerr(fptr);
	printf("Closing input file\n");
	fflush(fptr);
	fclose(fptr);
	debug.Write("Finished Data Transmit",8);
	}
//strcpy(transmit,"999 - End of Session\n");
//strcpy(transmit,"***END***\n");
//Write(clnt_socket,transmit,strlen(transmit));
close(clnt_socket);
debug.Write("Session Finished",8);
printf("Loop\n");
}

}

static int Get_Host_Name(char *buffer, int len)
{
struct utsname sys_name = { { 0 } };
int status=uname(&sys_name);
if (-1 != status)
	strncpy(buffer,sys_name.nodename,len);
return (status);
}

static int Write(int sock_descr, const void *msg_ptr, int bytes_to_send)
{
int bytes_written, num_sent=0;
for (bytes_written=0; bytes_written<bytes_to_send; bytes_written+=num_sent)
{
num_sent=write(sock_descr, (void *)((char *)msg_ptr + bytes_written),
		(bytes_to_send - bytes_written));
if (num_sent<0) 
{
printf("Write Error\n");
if (errno != EINTR) { exit(1); }
}

}
fclose(debug.stream);
return 0;
}

void shutdown(int sig)
{
debug.Write("DDG Shutdown",0);
printf("DDG Server Shutdown\n");
fflush(debug.stream);
fclose(debug.stream);
exit(0);
}
